You can find the PyTorch code to reproduce the first experiment in `experiment 1` and the code to reproduce the other experiments in `experiment 2 3`. The main algorithm implemented is the same, but we made changes to the dataset and training code due to differing training and evaluation procedures.
We did not have the time yet to merge all the changes into one code repository, so we provide these folders separately for now.

Across the two files, `train.py` is the main command-line interface for training and evaluation. Model code is split into `model.py` (general model code), `idspn.py` (our iDSPN implementation), `dspn.py` (from the DSPN repository), `slot.py` (Slot Attention implementation by lucidrains on GitHub).

To reproduce the exact hyperparameter and seeds used for our experiments, we use the launch scripts in `experiment 1/*.sh` and `experiment 2 3/scripts/*.sh`. The scripts to summarise or plot the results are `plot-clevr.py`, `plot-ran.py`, and `ran-results.py`. The dataset configuration can be found in `data.py`. For CLEVR evaluation, we ported over the average precision implementation to PyTorch in `ap.py`.